
clc;
clear all;
seedmax = 21;
median_num =11;


problems = {  'smd1()','smd2()','smd3()','smd4()','smd5()','smd6()','smd7()', 'smd8()', ...
    'smd4x(1,2,1)','smd6x(1,2,1)','smd7x(1,2,1)',  'smd8x(1,2,1)' };

algos = {  'vanillaEI', 'vanillaKB'}; %, 'generational'}; % 'generational'}
%algos = {'generational'};
legs = { 'EI', 'Believer', 'Gen.'};
colors = {'#D95319', 	'#A2142F', '#0072BD'};
colors = {[0 0.4470 0.7410], [0.8500 0.3250 0.0980], [0.9290 0.6940 0.1250]};
patten = {'-.o', '-.*', '-.+'};
legend_algos = legs;


np = length(problems);
% ns = length(seeds)
na = length(algos);

%--construct result save path
plotpath = strcat(pwd, '\plots');
if ~exist(plotpath)
    mkdir(plotpath);
end


best_fl = cell(1, np);
best_flnum = cell(1, np);
best_fu = cell(1, np);
best_funum = cell(1, np);

best_fl_norm = cell(1, np);
best_fu_norm = cell(1, np);



best_fl_core = cell(1, np);
best_flnum_core = cell(1, np);
best_fu_core = cell(1, np);
best_funum_core = cell(1, np);

best_fl_corenorm = cell(1, np);
best_fu_corenorm = cell(1, np);

bestfu_coreNatural = cell(1, np);
bestfl_coreNatural = cell(1, np);


out1 = 'experiment_2\';
% out1 = 'generational_2\';
% out1 = 'high_iter\';
% out1 = 'low_iter\';



% process each problem
for ii = 1: np
    prob = eval(problems{ii});
    nvar = prob.n_lvar;
    ninit = 20; % 11 * nvar - 1;
    
    %collect results for each algo
    algos_out = cell(1, na);
    best_fl{ii} = zeros(na , seedmax);
    best_flnum{ii} = zeros(na , seedmax);
    best_fu{ii} = zeros(na , seedmax);
    best_funum{ii} = zeros(na , seedmax);
    
    
    best_fl_core{ii} = zeros(na , seedmax);
    best_flnum_core{ii} = zeros(na , seedmax);
    best_fu_core{ii} = zeros(na , seedmax);
    best_funum_core{ii} = zeros(na , seedmax);
    
    bestfu_coreNatural{ii} = zeros(na , seedmax);
    bestfl_coreNatural{ii} = zeros(na, seedmax);

    
    for kk = 1:na
        algos_out{kk} = [];
        for jj = 1:seedmax
            % save folder and save name
            fout_folder   = strcat(pwd, '\result_folder\', out1 , prob.name, '_', num2str(nvar), '_', algos{kk});
            fout_file        = strcat(fout_folder, '\out_', num2str(jj), '.csv' ) 
            outmatrix      = csvread(fout_file);
            
            fout_file     = strcat(fout_folder, '\fu_', num2str(jj), '.csv')
            out_upper  = csvread(fout_file);
            
            fout_file = strcat(fout_folder, '\xu_', num2str(jj), '.csv');
            x_upper =  csvread(fout_file);
            
            fout_file     = strcat(fout_folder, '\fl_', num2str(jj), '.csv')
            out_lower = csvread(fout_file);
            
            fout_file = strcat(fout_folder, '\xl_', num2str(jj), '.csv');
            x_lower =  csvread(fout_file);
            
            %{problem}(algorithm, seed)
            best_fu{ii}(kk, jj) = abs(out_upper(end, :)- prob.uopt);
            best_fl{ii}(kk, jj) = abs(out_lower(end, :) - prob.lopt);
            
            
            
            
            best_funum{ii}(kk, jj) = outmatrix(2, 1);
            best_flnum{ii}(kk, jj) = outmatrix(2, 2);
            
            % without reevaluation
            %{problem}(algorithm, seed)
            out_upper = out_upper(1:end-1, :);
            out_lower = out_lower(1:end-1, :);
            x_upper = x_upper(1:end-1, :);
            x_lower =  x_lower(1:end-1, : );
            
          
             [best_x,best_f, best_c, s, index] = localsolver_startselection(x_upper, out_upper, []);
            
            best_fu_core{ii}(kk, jj) = abs(best_f - prob.uopt);
            best_fl_core{ii}(kk, jj)  = abs(out_lower(index, :) - prob.lopt); 
            
            bestfu_coreNatural{ii}(kk, jj) = best_f - prob.uopt;
            bestfl_coreNatural{ii}(kk, jj) = out_lower(index, :) - prob.lopt;
    
        end
    end
end

for ii = 1: np
    best_fl_norm{ii} =   (  best_fl{ii} - min(best_fl{ii}(:)) )/( max(best_fl{ii}(:))  - min(best_fl{ii}(:)) );
    best_fu_norm{ii} =   (  best_fu{ii} - min(best_fu{ii}(:)) )/( max(best_fu{ii}(:))  - min(best_fu{ii}(:)) );
    
     best_fl_corenorm{ii} =   (  best_fl_core{ii} - min(best_fl_core{ii}(:)) )/( max(best_fl_core{ii}(:))  - min(best_fl_core{ii}(:)) );
    best_fu_corenorm{ii} =   (  best_fu_core{ii} - min(best_fu_core{ii}(:)) )/( max(best_fu_core{ii}(:))  - min(best_fu_core{ii}(:)) );
    
end

% plot fu's convergence

% normalized median to csv
savename = strcat(pwd, '\result_folder\', out1, 'bl_mediansum_normalized.csv');
fp3=fopen(savename,'w');
fprintf(fp3, 'problem_method, ');

%--- median to csv
savename = strcat(pwd, '\result_folder\', out1, 'bl_median_all.csv');
fp=fopen(savename,'w');
fprintf(fp, 'problem_method, ');
for kk = 1 : na
    fprintf(fp3, algos{kk});
    fprintf(fp3, ' _core,');
end
for kk = 1 : na
    fprintf(fp3, algos{kk});
    fprintf(fp3, ' _reeval,');
end
 fprintf(fp3, ' \n');

savename2 = strcat(pwd, '\result_folder\', out1, 'lower_FEcount.csv');
fp2=fopen(savename2,'w');
fprintf(fp2, 'problem_method, ');
for kk = 1 : na
    fprintf(fp2, algos{kk});
    fprintf(fp2, ' ,');
end
 fprintf(fp2, ' \n');
 
 
 
for kk = 1 : na
    fprintf(fp, algos{kk});
    fprintf(fp, '_upper ,');
end

for kk = 1 : na
    fprintf(fp, algos{kk});
    fprintf(fp, '_lower ,');
end

for kk = 1 : na
    fprintf(fp, algos{kk});
    fprintf(fp, '_Reval_upper ,');
end

for kk = 1 : na
    fprintf(fp, algos{kk});
    fprintf(fp, '_Reval_lower ,');
end
fprintf(fp, '\n');

median_fu_core = zeros(np, na);
median_fl_core  = zeros(np, na);


median_fu_reeval = zeros(np, na);
median_fl_reeval  = zeros(np, na);
for ii = 1 : np
    figure(ii);
    prob = eval(problems{ii});
    fprintf(fp, prob.name);
    fprintf(fp, ',');
    
     fprintf(fp2, prob.name);
    fprintf(fp2, ',');
    
    med = zeros(1, 2);
    for jj = 1:na
        %{problem}(algorithm, seed)
        fu = best_fu_core{ii}(jj, :);
         median_fu_core(ii, jj) = median(fu);
        
        [~, id] = sort(fu);
        med(jj) = id(median_num);
        fprintf(fp, '%f,', median(fu));
        
       %  funorm = best_fu_corenorm{ii}(jj, :);
         % median_fu_core(ii, jj) = funorm(med(jj));
    end
    
    for jj = 1:na
        %{problem}(algorithm, seed)
        fl = best_fl_core{ii}(jj, :);
        fprintf(fp, '%f,', fl(med(jj)));
        median_fl_core(ii, jj) =  fl(med(jj));
        
        % flnorm =  best_fl_corenorm{ii}(jj, :);
       %  median_fl_core(ii, jj) =flnorm(med(jj));
    end
    
    %--------------count number
    for jj= 1:na
        fprintf(fp2, '%f,',  best_flnum{ii}(jj, med(jj)));
    end
     fprintf(fp2, '\n');
    
    % reevaluate
    med = zeros(1, 2);
    for jj = 1:na
        %{problem}(algorithm, seed)
        fu = best_fu{ii}(jj, :);
        [~, id] = sort(fu);
        med(jj) = id(median_num);
        median_fu_reeval(ii, jj) = median(fu);
        fprintf(fp, '%f,', median(fu)); %  fu(med)); median(fu)
        
        % funorm = best_fu_norm{ii}(jj, :);
        % median_fu_reeval(ii, jj) = funorm(med(jj));
        
        % ----------------------------------
        % --converge plot
        fout_folder = strcat(pwd, '\result_folder\', out1, '\',  prob.name, '_', num2str(nvar), '_', algos{jj});
        fout_file   = strcat(fout_folder, '\fu_', num2str(med(jj)), '.csv' );
        fu = csvread(fout_file);
        iteration = size(fu, 1);
        fu_conv = [];
        for mm = 20:iteration-1
            tmp = min(fu(1:mm));
            fu_conv = [fu_conv, tmp];
        end
        fu_conv = [fu_conv, fu(end)];
        
       
        xt = 20:iteration;
        plot(xt, fu_conv, patten{jj} ,'Color', 	colors{jj}, 'LineWidth', 2); hold on;
        %-----------------------------
    end
    for jj = 1:na
        %{problem}(algorithm, seed)
        fl = best_fl{ii}(jj, :);
        fprintf(fp, '%f,', fl(med(jj)));  
        median_fl_reeval(ii, jj) = fl(med(jj));
        
        % flnorm = best_fl_norm{ii}(jj, :);
        % median_fl_reeval(ii, jj) = flnorm(med(jj));
        
    end
    fprintf(fp, '\n');
    
    
    % a = get(gca,'XTickLabel');
    % set(gca,'XTickLabel',a,'fontsize',14);
 
    legend(legend_algos, 'fontsize', 20);
    xlim([20, 101]);
    xlabel('Iterations', 'fontsize', 18 );
    ylabel('F', 'fontsize', 18)
    ylh = get(gca,'ylabel');
    set(ylh, 'Rotation',0);

    savename = strcat(plotpath, '\', prob.name,'_', num2str(nvar), '_fu_3addonconv.png');
    saveas(figure(ii), savename);
    
    savename = strcat(plotpath, '\', prob.name,'_', num2str(nvar), '_fu_3addonconv.fig');
    saveas(figure(ii), savename);
    pause(0.2);
    close(figure(ii));
    
    
end

%---------------
median_fu_core = (median_fu_core - min(median_fu_core(:)) )/(max(median_fu_core(:)) - min(median_fu_core(:)));
median_fl_core = (median_fl_core - min(median_fl_core(:)) )/(max(median_fl_core(:)) - min(median_fl_core(:)));

median_fu_reeval = (median_fu_reeval - min(median_fu_reeval(:)) )/(max(median_fu_reeval(:)) - min(median_fu_reeval(:)));
median_fl_reeval = (median_fl_reeval - min(median_fl_reeval(:)) )/(max(median_fl_reeval(:)) - min(median_fl_reeval(:)));

for ii = 1:np
    prob = eval(problems{ii});
    fprintf(fp3, prob.name);
    fprintf(fp3, ',');
    for jj = 1:na
        fprintf(fp3, '%f,', median_fu_core(ii, jj) + median_fl_core(ii, jj));
    end
    for jj = 1:na
        fprintf(fp3, '%f,', median_fu_reeval(ii, jj) + median_fl_reeval(ii, jj));
    end   
    fprintf(fp3, '\n');
end
%-------------------
fclose(fp);
fclose(fp2);
fclose(fp3);
% check significance upper
% re-evaluate
for ii = 1:np
    alg_from{ii} = best_fu{ii}(2, :); % kb
    alg_to{ii}   = best_fu{ii}(1, :); % ei
end
alg_fromname = 'KB';
alg_toname  = {'EI'};
savename = strcat(pwd, '\result_folder\', out1, 'kb_ei_upper_reeval.csv');
significant_check(alg_from, alg_to, problems, alg_fromname, alg_toname, savename);

for ii = 1:np
    alg_from{ii} = best_fu_core{ii}(2, :); % kb
    alg_to{ii}   = best_fu_core{ii}(1, :); % ei
end
alg_fromname = 'KB';
alg_toname  = {'EI'};
savename = strcat(pwd, '\result_folder\', out1, 'kb_ei_upper_core.csv');
significant_check(alg_from, alg_to, problems, alg_fromname, alg_toname, savename);




function significant_check(alg_new, algo_base, problems, alg_newname,algo_basenames, savename)
% to    : baseline algorithms {problem}[seed-->] row
% from  : new algorithms      {problem}[algs|, seed-->] (col, row)
%---------------------------
np             = length(alg_new);      %
compare_na     = length(algo_basenames);
compare_sig    = zeros(np, compare_na);  %
compare_median = zeros(np, compare_na);
new_median     = zeros(np, 1);
for i = 1: np
    new_result  = alg_new{i}(:);
    new_median(i) = median(new_result);
    
    for j = 1: compare_na
        
        base_result = algo_base{i}(j, :);
        
        base_median = median(base_result);
        compare_median(i, j) = base_median;
        
        % check whether two results are same distribution
        [~, h] = ranksum(new_result, base_result);
        if h % logical 1, reject null (equal median at 5% sig level), accept difference
            
            [~, h_newsmall] = ranksum(new_result, base_result,'tail','left');
            if h_newsmall % logical 1, rejectl null (equal median), accept alternative new_result smaller
                compare_sig(i, j) = 1; % new smaller than base
            end
            
            [~, h_basesmall] = ranksum(new_result, base_result,'tail','right');
            if h_basesmall % logical 1, rejectl null (equal median), accept alternative new_result smaller
                compare_sig(i, j) = -1; % new bigger/worse than base
            end
        else
            compare_sig(i, j) = 0; % base/new no difference
        end
    end
end

fp=fopen(savename,'w');
fprintf(fp, 'problem_method, ');

for kk = 1 : compare_na
    fprintf(fp, algo_basenames{kk});
    fprintf(fp, ',%s, ', alg_newname);
    fprintf(fp, '%s, ', strcat(alg_newname, ' compared to ', algo_basenames{kk}, ','));
end
fprintf(fp, '\n');

for kk = 1 : np
    prob = eval(problems{kk});
    
    fprintf(fp,  prob.name);
    fprintf(fp,  ',');
    for  ii = 1 : compare_na
        fprintf(fp, '%f,', compare_median(kk, ii));
        fprintf(fp, '%f,', new_median(kk));
        fprintf(fp, '%d,', compare_sig (kk, ii) );
    end
    fprintf(fp, '\n');
end
fclose(fp);
end